Only show feedback for proposals that have been attempted using CSS
Closed, ResolvedPublic

Description

Currently when a quiz with multiple questions is submitted, all feedback is shown even if the proposals are not attempted.
The feedback for only those proposals which have been attempted show be shown.

We should hide these with CSS properties (i.e. 'display:none'), with the option of communities to overwrite this in Common.css if they want to show that feedback after all.

Mvolz created this task.Mar 8 2017, 2:17 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 8 2017, 2:17 PM

For quiz containing multiple questions, the aim is to show feedback for only those questions that have been attempted If I understand correctly ?

Mvolz added a comment.EditedJun 3 2017, 1:13 PM

For quiz containing multiple questions, the aim is to show feedback for only those questions that have been attempted If I understand correctly ?

No, even on a single question, it shows the feedback for every answer, even answers that weren't selected. It should only show feedback if the answer was correct or incorrect, i.e. the user selected the answer and it was wrong, or they didn't select an answer that was right.

I feel like it's unnecessary to show feedback for incorrect answers that were not selected.

Mvolz added a comment.Jun 3 2017, 1:15 PM

But maybe this needs a RFC (request for comment) from Wikiversity?

It was just something I personally found odd.

Mvolz added a comment.Jun 3 2017, 1:15 PM
This comment was removed by Mvolz.

It would also make sense to only have feedback for the question that has been attempted.Currently if a quiz has multiple questions, on submitting the quiz, the feedback for all questions are show.

Conditional feedback is another bug T166931 as suggested on the wishlist.
According to this, if the answer is correct for the question then feedback option 1 should be displayed and if the answer if wrong the feedback option 2 should be displayed.

Mvolz added a comment.Jun 3 2017, 1:50 PM

You can close this one or the other as a duplicate.

Harjotsingh renamed this task from Only show feedback for selected answers to Only show feedback for questions that have been attempted.Jun 3 2017, 1:55 PM
Harjotsingh updated the task description. (Show Details)

This task can deal with feedback in multiple questions while the other will deal with conditional feedback for each separate questions.

Change 357111 had a related patch set uploaded (by Harjotsingh; owner: Harjotsingh):
[mediawiki/extensions/Quiz@master] Show Feedback for only questions that have been attempted

https://gerrit.wikimedia.org/r/357111

I'm slightly uneasy about making this change without consulting community first: @Elitre @Whatamidoing-WMF maybe can weigh in?

I think the way it is currently done (to show all answers) is obviously wrong, but people may have created quizzes with that in mind.

I think maybe we should show screen shots of before and after on

https://en.wikiversity.org/wiki/Wikiversity:Colloquium

and https://fr.wikiversity.org is pretty active too but I don't know what the equivalent of the Collloquium is there?

Elitre added a comment.Jun 5 2017, 6:25 PM

I don't know what this is, so I will paste here the questions we are asking when CL support is requested (some parts may not apply). Although you may not need support strictly speaking, those may help us understand better the context.

  1. What is the problem?
  2. How does success of this task look like? How do we know when we are done?
  3. Is there any goal, program, project, team related with this request? Please provide links and use the corresponding Phabricator tags when available.
  4. What is your expected timeline from start to end? Is there a hard deadline?
Elitre moved this task from Backlog to Team radar on the Community-Liaisons board.

Change 357111 abandoned by Harjotsingh:
Show Feedback for only questions that have been attempted

Reason:
The task is duplicate and needs further discussion.

https://gerrit.wikimedia.org/r/357111

In case it is useful some time: The French equivalent of the English Colloquim is https://fr.wikiversity.org/wiki/Wikiversité:La_salle_café

(I would not be surprised if community members decided not to decide, but instead asked for the result to be configurable per-quiz.)

Change 357111 restored by Mvolz:
Show Feedback for only questions that have been attempted

Reason:
Not quite ready to abandon this one yet :).

https://gerrit.wikimedia.org/r/357111

Mvolz reopened this task as Open.Jun 11 2017, 6:50 AM
Mvolz added a comment.Jun 19 2017, 9:03 AM

We could do this with CSS as well; T148624

i.e. tag feedback that is unused with display;none and then add a class that allows people to show it if they want maybe?

Yes, Feedback of each question can be hidden and can be shown via toggle button through css and js, but this would make the feedback which is currently shown in mobile devices to always be hidden due to absence of JavaScript.

Mvolz added a comment.Jun 19 2017, 1:54 PM

I don't think we'd use JS, I think we'd want the style described somewhere in the quiz itself, see T148624. By having the classes then the CSS could be applied accordingly to hide or show from the outset.

Mvolz renamed this task from Only show feedback for questions that have been attempted to Only show feedback for questions that have been attempted using CSS.Jul 17 2017, 10:32 AM
Mvolz removed a project: Patch-For-Review.
Mvolz updated the task description. (Show Details)

Change 368341 had a related patch set uploaded (by Harjotsingh; owner: Harjotsingh):
[mediawiki/extensions/Quiz@master] Add feedbackDisplay class to feedback( correction ) in quiz to hide/show feedback

https://gerrit.wikimedia.org/r/368341

Css class can be added to feedback which can hide/show all the feedback from Common.css.
This won't be able to hide feedback of only those question that have not been attempted, it will simply hide all the feedback.

I've added feedbackDisplay class, this can be used in Common.css to hide feedback on all quizzes by simply using display attribute or it can be used with quizId (used in form inside quiz class) which will hide feedback only one the quiz whose id is given and many more possibilities exist according to CSS.

Change 368536 had a related patch set uploaded (by Harjotsingh; owner: Harjotsingh):
[mediawiki/extensions/Quiz@master] Add feedbackDisplay class to questions that have not been attempted

https://gerrit.wikimedia.org/r/368536

Change 368341 abandoned by Harjotsingh:
Add feedbackDisplay class to feedback( correction ) in quiz to hide/show feedback

Reason:
I made a change at https://gerrit.wikimedia.org/r/#/c/368536/
I should have edited this change only, but I made a new branch and couldn't merge it with this ...

https://gerrit.wikimedia.org/r/368341

Change 357111 abandoned by Harjotsingh:
Show Feedback for only questions that have been attempted

Reason:
Made a new change that uses CSS to control this feature.
Therefore abandoning this one.

https://gerrit.wikimedia.org/r/357111

I am little confused on how this is supposed to work from the quiz writer perspective. Right now, if I don't want a quiz to have feedback, I do not incorporate it in the source code. If the quiz has feedback in the source code, it is shown for all questions that have it regardless of whether the user passed or failed the question.

I thought the idea (as described in T166931) was to:

  1. Show feedback only if the user attempted the question.
  2. Show different feedback depending on whether the answer was correct or incorrect
  3. Provide a fallback mechanism to keep the current behavior by default.

However, I am not sure how that can be archived with this new class. Is it possible to see an example on how this is supposed to work?

If the feedback is added to the source code then It is shown as per current behaviour.

This task is to show feedback only if user has attempted the question.
It doesn't cover 2nd point (Conditional feedback) that you specified.

The fallback mechanism is based on the fact that the Admins/Sysops user of Wikiversity can change Common.css (Add predefined CSS) and it would result in the quiz to show all feedback that has been added to code irrespective of the fact that it was attempted or not.

Ok, so this change will modify the default behavior for the whole wiki. No changes needed to the individual quizzes. And if a community wants to revert to the old behavior, they can add a code like this to their Common.css.

.feedbackDisplay {
    display: none;
}

Am I right?

Currently the way the patch is, the default behaviour for whole wiki would be to only show feedback of attempted questions.

If the Admin/Community adds

.feedbackUnselected{
  display:block;
}

to Mediawiki:Common.css then it will revert to showing all feedback.

Got it. Thank you very much!

Mvolz added a subscriber: Reedy.Aug 14 2017, 9:35 AM

@Reedy any chance you can take a look at https://gerrit.wikimedia.org/r/#/c/368536/ ? I can't get it to work on localhost.

Can anyone confirm the patch on localhost ?

It seems stuck right now

Harjotsingh renamed this task from Only show feedback for questions that have been attempted using CSS to Only show feedback for proposals that have been attempted using CSS.Aug 23 2017, 3:30 PM
Harjotsingh updated the task description. (Show Details)

Change 373310 had a related patch set uploaded (by Harjotsingh; owner: Harjotsingh):
[mediawiki/extensions/Quiz@master] Add feedbackUnselected class to proposals that have not been attempted

https://gerrit.wikimedia.org/r/373310

Change 368536 abandoned by Harjotsingh:
Add feedbackDisplay class to questions that have not been attempted

Reason:
new change at https://gerrit.wikimedia.org/r/#/c/373310/

https://gerrit.wikimedia.org/r/368536

Change 373310 merged by jenkins-bot:
[mediawiki/extensions/Quiz@master] Add unselected class to proposals that have not been attempted

https://gerrit.wikimedia.org/r/373310

Harjotsingh closed this task as Resolved.Aug 25 2017, 2:31 PM
Mvolz added a comment.Aug 25 2017, 7:40 PM

This also needs to be announced on all wikis and admins need to be told how
to undo it.

This also needs to be announced on all wikis and admins need to be told how
to undo it.

Maybe add to documentation ?

Mvolz added a comment.Aug 26 2017, 9:20 AM

Yes, but it also needs to be announced, preferably before it goes live, so
admins have a chance to preemptively undo it.

Mvolz added a comment.Aug 26 2017, 7:15 PM

Ok, we should add it to the other language wikiversities as well.